
local IphiKM = CreateFrame("Frame");
IphiKM:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
local myName = UnitName("player");

if IkmDB == nil then
	IkmDB = {
		['message'] = "Kick : <@TARGET@> - @SPELLNAME@ interrupted !",
		['channel'] = "PARTY"
	}
end


local IphiKM_OnEvent = function(self, event, ...)
	
	local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2 = select(1, ...)
	-- 4.2: timestamp, event, hideCaster, srcGUID, srcName, srcFlags, srcFlags2, dstGUID, dstName, dstFlags, dstFlags2
		local petName, _ = UnitName("pet");
		if (sourceName == myName and type == "SPELL_INTERRUPT") or (sourceName == petName and type == "SPELL_INTERRUPT") then
			
			local extraSpellId, extraSpellName = select(15, ...)
			local finalMessage = string.gsub(IkmDB['message'], "@TARGET@", destName)
			finalMessage = string.gsub(finalMessage, "@SPELLNAME@", GetSpellLink("" .. extraSpellId))
			finalMessage = string.gsub(finalMessage, "@PLAYERNAME@", myName)
			if (petName ~= nil) then finalMessage = string.gsub(finalMessage, "@PETNAME@", petName) end
			
			local finalChannel;
			if IkmDB['channel'] == 'AUTO' then
			
				if (GetNumRaidMembers() ~= 0) then finalChannel = 'RAID'
				else
					if (GetNumPartyMembers() ~= 0) then finalChannel = 'PARTY'
					else finalChannel = 'SAY'
					end
				end
				
			else finalChannel = IkmDB['channel'] end
			
			SendChatMessage(finalMessage, finalChannel);
		end
	
end

IphiKM:SetScript("OnEvent", IphiKM_OnEvent);

local saveKickMessage = function(slash)
	
	local dataT = strsub(slash, 0, 7);
	IkmDB[dataT] = strsub(slash, 9);
	
	print("|cffDE83DCIphiKickMachine |r: <" .. dataT .."> set to |cff83B9DE" .. strsub(slash, 9) .."|r")
	
end

SLASH_IPHIKICKMACHINE1 = '/ikm';
SlashCmdList['IPHIKICKMACHINE'] = saveKickMessage